x1 = 100
y1 = 500

x2 = 100
y2 = 100

x3 = 700
y3 = 100

x4 = 700
y4 = 500

mouseDown = false
pointDown = 0

function getPoint(x1, y1, x2, y2, _t)
	local x = x1 + _t * (x2 - x1)
	local y = y1 + _t * (y2 - y1)
	
	--[[
	local length = math.sqrt(x * x + y * y)
	local stepx = x / length
	local stepy = y / length

	x = x1
	y = y1

	for i = 0, _t do
		x = x + stepx
		y = y + stepy
	end
	]]

	return math.floor(x + .5), math.floor(y + .5)
end

function love.load()
	love.graphics.setPointSize(1)
end

function love.update(dt)
	if mouseDown then
		if pointDown == 1 then
			x1 = love.mouse.getX()
			y1 = love.mouse.getY()
		elseif pointDown == 2 then
			x2 = love.mouse.getX()
			y2 = love.mouse.getY()
		elseif pointDown == 3 then
			x3 = love.mouse.getX()
			y3 = love.mouse.getY()
		elseif pointDown == 4 then
			x4 = love.mouse.getX()
			y4 = love.mouse.getY()
		end
	end
end

function love.draw()
	love.graphics.setColor(255, 255, 255, 255)
	love.graphics.print("FPS: " .. love.timer.getFPS(), 0, 0)

	love.graphics.setColor(255, 255, 255, 128)
	love.graphics.line(x1, y1, x2, y2)
	love.graphics.line(x2, y2, x3, y3)
	love.graphics.line(x3, y3, x4, y4)

	love.graphics.setColor(255, 255, 255, 255)
	love.graphics.rectangle("line", x1 - 5, y1 - 5, 10, 10)
	love.graphics.rectangle("line", x2 - 5, y2 - 5, 10, 10)
	love.graphics.rectangle("line", x3 - 5, y3 - 5, 10, 10)
	love.graphics.rectangle("line", x4 - 5, y4 - 5, 10, 10)

	love.graphics.setColor(255, 0, 0, 255)

	local highest = x4
	local lowest = x1

	local lastX = x1
	local lastY = y1

	if x4 < x1 then
		highest = x1
		lowest = x4
	end

	for t = 0, 1, 1 / (highest - lowest) do
		local _x1, _y1 = getPoint(x1, y1, x2, y2, t)
		local _x2, _y2 = getPoint(x2, y2, x3, y3, t)

		local __x1, __y1 = getPoint(x2, y2, x3, y3, t)
		local __x2, __y2 = getPoint(x3, y3, x4, y4, t)

		local ___x1, ___y1 = getPoint(_x1, _y1, _x2, _y2, t)
		local ___x2, ___y2 = getPoint(__x1, __y1, __x2, __y2, t)

		local x, y = getPoint(___x1, ___y1, ___x2, ___y2, t)
		love.graphics.point(x, y)
		love.graphics.line(x, y, lastX, lastY)

		lastX = x
		lastY = y
	end
end

function love.mousepressed(x, y, button)
	if button == "l" then
		if x > x1 - 5 and x < x1 + 5 and y > y1 - 5 and y < y1 + 5 then
			mouseDown = true
			pointDown = 1
		elseif x > x2 - 5 and x < x2 + 5 and y > y2 - 5 and y < y2 + 5 then
			mouseDown = true
			pointDown = 2
		elseif x > x3 - 5 and x < x3 + 5 and y > y3 - 5 and y < y3 + 5 then
			mouseDown = true
			pointDown = 3
		elseif x > x4 - 5 and x < x4 + 5 and y > y4 - 5 and y < y4 + 5 then
			mouseDown = true
			pointDown = 4
		end
	end
end

function love.mousereleased(x, y, button)
	if button == "l" then
		mouseDown = false
	end
end